# API Reference <a name="API Reference" id="api-reference"></a>

## Constructs <a name="Constructs" id="Constructs"></a>

### Opensearch <a name="Opensearch" id="fnl-aws-cdk.Opensearch"></a>

#### Initializers <a name="Initializers" id="fnl-aws-cdk.Opensearch.Initializer"></a>

```typescript
import { Opensearch } from 'fnl-aws-cdk'

new Opensearch(scope: Construct, id: string, props: CustomProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#fnl-aws-cdk.Opensearch.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#fnl-aws-cdk.Opensearch.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#fnl-aws-cdk.Opensearch.Initializer.parameter.props">props</a></code> | <code><a href="#fnl-aws-cdk.CustomProps">CustomProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="fnl-aws-cdk.Opensearch.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="fnl-aws-cdk.Opensearch.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="fnl-aws-cdk.Opensearch.Initializer.parameter.props"></a>

- *Type:* <a href="#fnl-aws-cdk.CustomProps">CustomProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#fnl-aws-cdk.Opensearch.toString">toString</a></code> | Returns a string representation of this construct. |

---

##### `toString` <a name="toString" id="fnl-aws-cdk.Opensearch.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#fnl-aws-cdk.Opensearch.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="fnl-aws-cdk.Opensearch.isConstruct"></a>

```typescript
import { Opensearch } from 'fnl-aws-cdk'

Opensearch.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="fnl-aws-cdk.Opensearch.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#fnl-aws-cdk.Opensearch.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="fnl-aws-cdk.Opensearch.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---


## Structs <a name="Structs" id="Structs"></a>

### CustomProps <a name="CustomProps" id="fnl-aws-cdk.CustomProps"></a>

#### Initializer <a name="Initializer" id="fnl-aws-cdk.CustomProps.Initializer"></a>

```typescript
import { CustomProps } from 'fnl-aws-cdk'

const customProps: CustomProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#fnl-aws-cdk.CustomProps.property.version">version</a></code> | <code>aws-cdk-lib.aws_opensearchservice.EngineVersion</code> | The Elasticsearch/OpenSearch version that your domain will leverage. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.accessPolicies">accessPolicies</a></code> | <code>aws-cdk-lib.aws_iam.PolicyStatement[]</code> | Domain access policies. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.advancedOptions">advancedOptions</a></code> | <code>{[ key: string ]: string}</code> | Additional options to specify for the Amazon OpenSearch Service domain. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.automatedSnapshotStartHour">automatedSnapshotStartHour</a></code> | <code>number</code> | The hour in UTC during which the service takes an automated daily snapshot of the indices in the Amazon OpenSearch Service domain. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.capacity">capacity</a></code> | <code>aws-cdk-lib.aws_opensearchservice.CapacityConfig</code> | The cluster capacity configuration for the Amazon OpenSearch Service domain. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.cognitoDashboardsAuth">cognitoDashboardsAuth</a></code> | <code>aws-cdk-lib.aws_opensearchservice.CognitoOptions</code> | Configures Amazon OpenSearch Service to use Amazon Cognito authentication for OpenSearch Dashboards. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.coldStorageEnabled">coldStorageEnabled</a></code> | <code>boolean</code> | Whether to enable or disable cold storage on the domain. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.customEndpoint">customEndpoint</a></code> | <code>aws-cdk-lib.aws_opensearchservice.CustomEndpointOptions</code> | To configure a custom domain configure these options. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.domainName">domainName</a></code> | <code>string</code> | Enforces a particular physical domain name. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.ebs">ebs</a></code> | <code>aws-cdk-lib.aws_opensearchservice.EbsOptions</code> | The configurations of Amazon Elastic Block Store (Amazon EBS) volumes that are attached to data nodes in the Amazon OpenSearch Service domain. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.enableAutoSoftwareUpdate">enableAutoSoftwareUpdate</a></code> | <code>boolean</code> | Specifies whether automatic service software updates are enabled for the domain. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.enableVersionUpgrade">enableVersionUpgrade</a></code> | <code>boolean</code> | To upgrade an Amazon OpenSearch Service domain to a new version, rather than replacing the entire domain resource, use the EnableVersionUpgrade update policy. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.encryptionAtRest">encryptionAtRest</a></code> | <code>aws-cdk-lib.aws_opensearchservice.EncryptionAtRestOptions</code> | Encryption at rest options for the cluster. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.enforceHttps">enforceHttps</a></code> | <code>boolean</code> | True to require that all traffic to the domain arrive over HTTPS. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.fineGrainedAccessControl">fineGrainedAccessControl</a></code> | <code>aws-cdk-lib.aws_opensearchservice.AdvancedSecurityOptions</code> | Specifies options for fine-grained access control. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.ipAddressType">ipAddressType</a></code> | <code>aws-cdk-lib.aws_opensearchservice.IpAddressType</code> | Specify either dual stack or IPv4 as your IP address type. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.logging">logging</a></code> | <code>aws-cdk-lib.aws_opensearchservice.LoggingOptions</code> | Configuration log publishing configuration options. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.nodeToNodeEncryption">nodeToNodeEncryption</a></code> | <code>boolean</code> | Specify true to enable node to node encryption. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.offPeakWindowEnabled">offPeakWindowEnabled</a></code> | <code>boolean</code> | Options for enabling a domain's off-peak window, during which OpenSearch Service can perform mandatory configuration changes on the domain. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.offPeakWindowStart">offPeakWindowStart</a></code> | <code>aws-cdk-lib.aws_opensearchservice.WindowStartTime</code> | Start time for the off-peak window, in Coordinated Universal Time (UTC). |
| <code><a href="#fnl-aws-cdk.CustomProps.property.removalPolicy">removalPolicy</a></code> | <code>aws-cdk-lib.RemovalPolicy</code> | Policy to apply when the domain is removed from the stack. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.securityGroups">securityGroups</a></code> | <code>aws-cdk-lib.aws_ec2.ISecurityGroup[]</code> | The list of security groups that are associated with the VPC endpoints for the domain. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.suppressLogsResourcePolicy">suppressLogsResourcePolicy</a></code> | <code>boolean</code> | Specify whether to create a CloudWatch Logs resource policy or not. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.tlsSecurityPolicy">tlsSecurityPolicy</a></code> | <code>aws-cdk-lib.aws_opensearchservice.TLSSecurityPolicy</code> | The minimum TLS version required for traffic to the domain. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.useUnsignedBasicAuth">useUnsignedBasicAuth</a></code> | <code>boolean</code> | Configures the domain so that unsigned basic auth is enabled. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.vpc">vpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | Place the domain inside this VPC. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.vpcSubnets">vpcSubnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection[]</code> | The specific vpc subnets the domain will be placed in. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.zoneAwareness">zoneAwareness</a></code> | <code>aws-cdk-lib.aws_opensearchservice.ZoneAwarenessConfig</code> | The cluster zone awareness configuration for the Amazon OpenSearch Service domain. |
| <code><a href="#fnl-aws-cdk.CustomProps.property.masteruser">masteruser</a></code> | <code>string</code> | *No description.* |
| <code><a href="#fnl-aws-cdk.CustomProps.property.program">program</a></code> | <code>string</code> | *No description.* |
| <code><a href="#fnl-aws-cdk.CustomProps.property.project">project</a></code> | <code>string</code> | *No description.* |
| <code><a href="#fnl-aws-cdk.CustomProps.property.tier">tier</a></code> | <code>string</code> | *No description.* |

---

##### `version`<sup>Required</sup> <a name="version" id="fnl-aws-cdk.CustomProps.property.version"></a>

```typescript
public readonly version: EngineVersion;
```

- *Type:* aws-cdk-lib.aws_opensearchservice.EngineVersion

The Elasticsearch/OpenSearch version that your domain will leverage.

---

##### `accessPolicies`<sup>Optional</sup> <a name="accessPolicies" id="fnl-aws-cdk.CustomProps.property.accessPolicies"></a>

```typescript
public readonly accessPolicies: PolicyStatement[];
```

- *Type:* aws-cdk-lib.aws_iam.PolicyStatement[]
- *Default:* No access policies.

Domain access policies.

---

##### `advancedOptions`<sup>Optional</sup> <a name="advancedOptions" id="fnl-aws-cdk.CustomProps.property.advancedOptions"></a>

```typescript
public readonly advancedOptions: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}
- *Default:* no advanced options are specified

Additional options to specify for the Amazon OpenSearch Service domain.

> [https://docs.aws.amazon.com/opensearch-service/latest/developerguide/createupdatedomains.html#createdomain-configure-advanced-options](https://docs.aws.amazon.com/opensearch-service/latest/developerguide/createupdatedomains.html#createdomain-configure-advanced-options)

---

##### `automatedSnapshotStartHour`<sup>Optional</sup> <a name="automatedSnapshotStartHour" id="fnl-aws-cdk.CustomProps.property.automatedSnapshotStartHour"></a>

```typescript
public readonly automatedSnapshotStartHour: number;
```

- *Type:* number
- *Default:* Hourly automated snapshots not used

The hour in UTC during which the service takes an automated daily snapshot of the indices in the Amazon OpenSearch Service domain.

Only applies for Elasticsearch versions
below 5.3.

---

##### `capacity`<sup>Optional</sup> <a name="capacity" id="fnl-aws-cdk.CustomProps.property.capacity"></a>

```typescript
public readonly capacity: CapacityConfig;
```

- *Type:* aws-cdk-lib.aws_opensearchservice.CapacityConfig
- *Default:* 1 r5.large.search data node; no dedicated master nodes.

The cluster capacity configuration for the Amazon OpenSearch Service domain.

---

##### `cognitoDashboardsAuth`<sup>Optional</sup> <a name="cognitoDashboardsAuth" id="fnl-aws-cdk.CustomProps.property.cognitoDashboardsAuth"></a>

```typescript
public readonly cognitoDashboardsAuth: CognitoOptions;
```

- *Type:* aws-cdk-lib.aws_opensearchservice.CognitoOptions
- *Default:* Cognito not used for authentication to OpenSearch Dashboards.

Configures Amazon OpenSearch Service to use Amazon Cognito authentication for OpenSearch Dashboards.

---

##### `coldStorageEnabled`<sup>Optional</sup> <a name="coldStorageEnabled" id="fnl-aws-cdk.CustomProps.property.coldStorageEnabled"></a>

```typescript
public readonly coldStorageEnabled: boolean;
```

- *Type:* boolean
- *Default:* undefined

Whether to enable or disable cold storage on the domain.

You must enable UltraWarm storage to enable cold storage.

> [https://docs.aws.amazon.com/opensearch-service/latest/developerguide/cold-storage.html](https://docs.aws.amazon.com/opensearch-service/latest/developerguide/cold-storage.html)

---

##### `customEndpoint`<sup>Optional</sup> <a name="customEndpoint" id="fnl-aws-cdk.CustomProps.property.customEndpoint"></a>

```typescript
public readonly customEndpoint: CustomEndpointOptions;
```

- *Type:* aws-cdk-lib.aws_opensearchservice.CustomEndpointOptions
- *Default:* no custom domain endpoint will be configured

To configure a custom domain configure these options.

If you specify a Route53 hosted zone it will create a CNAME record and use DNS validation for the certificate

---

##### `domainName`<sup>Optional</sup> <a name="domainName" id="fnl-aws-cdk.CustomProps.property.domainName"></a>

```typescript
public readonly domainName: string;
```

- *Type:* string
- *Default:* A name will be auto-generated.

Enforces a particular physical domain name.

---

##### `ebs`<sup>Optional</sup> <a name="ebs" id="fnl-aws-cdk.CustomProps.property.ebs"></a>

```typescript
public readonly ebs: EbsOptions;
```

- *Type:* aws-cdk-lib.aws_opensearchservice.EbsOptions
- *Default:* 10 GiB General Purpose (SSD) volumes per node.

The configurations of Amazon Elastic Block Store (Amazon EBS) volumes that are attached to data nodes in the Amazon OpenSearch Service domain.

---

##### `enableAutoSoftwareUpdate`<sup>Optional</sup> <a name="enableAutoSoftwareUpdate" id="fnl-aws-cdk.CustomProps.property.enableAutoSoftwareUpdate"></a>

```typescript
public readonly enableAutoSoftwareUpdate: boolean;
```

- *Type:* boolean
- *Default:* false

Specifies whether automatic service software updates are enabled for the domain.

> [https://docs.aws.amazon.com/it_it/AWSCloudFormation/latest/UserGuide/aws-properties-opensearchservice-domain-softwareupdateoptions.html](https://docs.aws.amazon.com/it_it/AWSCloudFormation/latest/UserGuide/aws-properties-opensearchservice-domain-softwareupdateoptions.html)

---

##### `enableVersionUpgrade`<sup>Optional</sup> <a name="enableVersionUpgrade" id="fnl-aws-cdk.CustomProps.property.enableVersionUpgrade"></a>

```typescript
public readonly enableVersionUpgrade: boolean;
```

- *Type:* boolean
- *Default:* false

To upgrade an Amazon OpenSearch Service domain to a new version, rather than replacing the entire domain resource, use the EnableVersionUpgrade update policy.

> [https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-attribute-updatepolicy.html#cfn-attributes-updatepolicy-upgradeopensearchdomain](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-attribute-updatepolicy.html#cfn-attributes-updatepolicy-upgradeopensearchdomain)

---

##### `encryptionAtRest`<sup>Optional</sup> <a name="encryptionAtRest" id="fnl-aws-cdk.CustomProps.property.encryptionAtRest"></a>

```typescript
public readonly encryptionAtRest: EncryptionAtRestOptions;
```

- *Type:* aws-cdk-lib.aws_opensearchservice.EncryptionAtRestOptions
- *Default:* No encryption at rest

Encryption at rest options for the cluster.

---

##### `enforceHttps`<sup>Optional</sup> <a name="enforceHttps" id="fnl-aws-cdk.CustomProps.property.enforceHttps"></a>

```typescript
public readonly enforceHttps: boolean;
```

- *Type:* boolean
- *Default:* false

True to require that all traffic to the domain arrive over HTTPS.

---

##### `fineGrainedAccessControl`<sup>Optional</sup> <a name="fineGrainedAccessControl" id="fnl-aws-cdk.CustomProps.property.fineGrainedAccessControl"></a>

```typescript
public readonly fineGrainedAccessControl: AdvancedSecurityOptions;
```

- *Type:* aws-cdk-lib.aws_opensearchservice.AdvancedSecurityOptions
- *Default:* fine-grained access control is disabled

Specifies options for fine-grained access control.

Requires Elasticsearch version 6.7 or later or OpenSearch version 1.0 or later. Enabling fine-grained access control
also requires encryption of data at rest and node-to-node encryption, along with
enforced HTTPS.

---

##### `ipAddressType`<sup>Optional</sup> <a name="ipAddressType" id="fnl-aws-cdk.CustomProps.property.ipAddressType"></a>

```typescript
public readonly ipAddressType: IpAddressType;
```

- *Type:* aws-cdk-lib.aws_opensearchservice.IpAddressType
- *Default:* IpAddressType.IPV4

Specify either dual stack or IPv4 as your IP address type.

Dual stack allows you to share domain resources across IPv4 and IPv6 address types, and is the recommended option.

If you set your IP address type to dual stack, you can't change your address type later.

---

##### `logging`<sup>Optional</sup> <a name="logging" id="fnl-aws-cdk.CustomProps.property.logging"></a>

```typescript
public readonly logging: LoggingOptions;
```

- *Type:* aws-cdk-lib.aws_opensearchservice.LoggingOptions
- *Default:* No logs are published

Configuration log publishing configuration options.

---

##### `nodeToNodeEncryption`<sup>Optional</sup> <a name="nodeToNodeEncryption" id="fnl-aws-cdk.CustomProps.property.nodeToNodeEncryption"></a>

```typescript
public readonly nodeToNodeEncryption: boolean;
```

- *Type:* boolean
- *Default:* Node to node encryption is not enabled.

Specify true to enable node to node encryption.

Requires Elasticsearch version 6.0 or later or OpenSearch version 1.0 or later.

---

##### `offPeakWindowEnabled`<sup>Optional</sup> <a name="offPeakWindowEnabled" id="fnl-aws-cdk.CustomProps.property.offPeakWindowEnabled"></a>

```typescript
public readonly offPeakWindowEnabled: boolean;
```

- *Type:* boolean
- *Default:* Disabled for domains created before February 16, 2023. Enabled for domains created after. Enabled if `offPeakWindowStart` is set.

Options for enabling a domain's off-peak window, during which OpenSearch Service can perform mandatory configuration changes on the domain.

Off-peak windows were introduced on February 16, 2023.
All domains created before this date have the off-peak window disabled by default.
You must manually enable and configure the off-peak window for these domains.
All domains created after this date will have the off-peak window enabled by default.
You can't disable the off-peak window for a domain after it's enabled.

> [https://docs.aws.amazon.com/it_it/AWSCloudFormation/latest/UserGuide/aws-properties-opensearchservice-domain-offpeakwindow.html](https://docs.aws.amazon.com/it_it/AWSCloudFormation/latest/UserGuide/aws-properties-opensearchservice-domain-offpeakwindow.html)

---

##### `offPeakWindowStart`<sup>Optional</sup> <a name="offPeakWindowStart" id="fnl-aws-cdk.CustomProps.property.offPeakWindowStart"></a>

```typescript
public readonly offPeakWindowStart: WindowStartTime;
```

- *Type:* aws-cdk-lib.aws_opensearchservice.WindowStartTime
- *Default:* 10:00 P.M. local time

Start time for the off-peak window, in Coordinated Universal Time (UTC).

The window length will always be 10 hours, so you can't specify an end time.
For example, if you specify 11:00 P.M. UTC as a start time, the end time will automatically be set to 9:00 A.M.

---

##### `removalPolicy`<sup>Optional</sup> <a name="removalPolicy" id="fnl-aws-cdk.CustomProps.property.removalPolicy"></a>

```typescript
public readonly removalPolicy: RemovalPolicy;
```

- *Type:* aws-cdk-lib.RemovalPolicy
- *Default:* RemovalPolicy.RETAIN

Policy to apply when the domain is removed from the stack.

---

##### `securityGroups`<sup>Optional</sup> <a name="securityGroups" id="fnl-aws-cdk.CustomProps.property.securityGroups"></a>

```typescript
public readonly securityGroups: ISecurityGroup[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISecurityGroup[]
- *Default:* One new security group is created.

The list of security groups that are associated with the VPC endpoints for the domain.

Only used if `vpc` is specified.

> [https://docs.aws.amazon.com/vpc/latest/userguide/VPC_SecurityGroups.html](https://docs.aws.amazon.com/vpc/latest/userguide/VPC_SecurityGroups.html)

---

##### `suppressLogsResourcePolicy`<sup>Optional</sup> <a name="suppressLogsResourcePolicy" id="fnl-aws-cdk.CustomProps.property.suppressLogsResourcePolicy"></a>

```typescript
public readonly suppressLogsResourcePolicy: boolean;
```

- *Type:* boolean
- *Default:* false

Specify whether to create a CloudWatch Logs resource policy or not.

When logging is enabled for the domain, a CloudWatch Logs resource policy is created by default.
However, CloudWatch Logs supports only 10 resource policies per region.
If you enable logging for several domains, it may hit the quota and cause an error.
By setting this property to true, creating a resource policy is suppressed, allowing you to avoid this problem.

If you set this option to true, you must create a resource policy before deployment.

> [https://docs.aws.amazon.com/opensearch-service/latest/developerguide/createdomain-configure-slow-logs.html](https://docs.aws.amazon.com/opensearch-service/latest/developerguide/createdomain-configure-slow-logs.html)

---

##### `tlsSecurityPolicy`<sup>Optional</sup> <a name="tlsSecurityPolicy" id="fnl-aws-cdk.CustomProps.property.tlsSecurityPolicy"></a>

```typescript
public readonly tlsSecurityPolicy: TLSSecurityPolicy;
```

- *Type:* aws-cdk-lib.aws_opensearchservice.TLSSecurityPolicy
- *Default:* TLSSecurityPolicy.TLS_1_2

The minimum TLS version required for traffic to the domain.

---

##### `useUnsignedBasicAuth`<sup>Optional</sup> <a name="useUnsignedBasicAuth" id="fnl-aws-cdk.CustomProps.property.useUnsignedBasicAuth"></a>

```typescript
public readonly useUnsignedBasicAuth: boolean;
```

- *Type:* boolean
- *Default:* false

Configures the domain so that unsigned basic auth is enabled.

If no master user is provided a default master user
with username `admin` and a dynamically generated password stored in KMS is created. The password can be retrieved
by getting `masterUserPassword` from the domain instance.

Setting this to true will also add an access policy that allows unsigned
access, enable node to node encryption, encryption at rest. If conflicting
settings are encountered (like disabling encryption at rest) enabling this
setting will cause a failure.

---

##### `vpc`<sup>Optional</sup> <a name="vpc" id="fnl-aws-cdk.CustomProps.property.vpc"></a>

```typescript
public readonly vpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc
- *Default:* Domain is not placed in a VPC.

Place the domain inside this VPC.

> [https://docs.aws.amazon.com/opensearch-service/latest/developerguide/vpc.html](https://docs.aws.amazon.com/opensearch-service/latest/developerguide/vpc.html)

---

##### `vpcSubnets`<sup>Optional</sup> <a name="vpcSubnets" id="fnl-aws-cdk.CustomProps.property.vpcSubnets"></a>

```typescript
public readonly vpcSubnets: SubnetSelection[];
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection[]
- *Default:* All private subnets.

The specific vpc subnets the domain will be placed in.

You must provide one subnet for each Availability Zone
that your domain uses. For example, you must specify three subnet IDs for a three Availability Zone
domain.

Only used if `vpc` is specified.

> [https://docs.aws.amazon.com/vpc/latest/userguide/VPC_Subnets.html](https://docs.aws.amazon.com/vpc/latest/userguide/VPC_Subnets.html)

---

##### `zoneAwareness`<sup>Optional</sup> <a name="zoneAwareness" id="fnl-aws-cdk.CustomProps.property.zoneAwareness"></a>

```typescript
public readonly zoneAwareness: ZoneAwarenessConfig;
```

- *Type:* aws-cdk-lib.aws_opensearchservice.ZoneAwarenessConfig
- *Default:* no zone awareness (1 AZ)

The cluster zone awareness configuration for the Amazon OpenSearch Service domain.

---

##### `masteruser`<sup>Required</sup> <a name="masteruser" id="fnl-aws-cdk.CustomProps.property.masteruser"></a>

```typescript
public readonly masteruser: string;
```

- *Type:* string

---

##### `program`<sup>Required</sup> <a name="program" id="fnl-aws-cdk.CustomProps.property.program"></a>

```typescript
public readonly program: string;
```

- *Type:* string

---

##### `project`<sup>Required</sup> <a name="project" id="fnl-aws-cdk.CustomProps.property.project"></a>

```typescript
public readonly project: string;
```

- *Type:* string

---

##### `tier`<sup>Required</sup> <a name="tier" id="fnl-aws-cdk.CustomProps.property.tier"></a>

```typescript
public readonly tier: string;
```

- *Type:* string

---



